VERSION 4.00
Begin VB.Form FormFilter 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "MIDI In Filtering"
   ClientHeight    =   7035
   ClientLeft      =   1860
   ClientTop       =   1785
   ClientWidth     =   5130
   BeginProperty Font 
      name            =   "MS Sans Serif"
      charset         =   0
      weight          =   700
      size            =   8.25
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   7440
   Icon            =   "FILTER.frx":0000
   Left            =   1800
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   7035
   ScaleWidth      =   5130
   Top             =   1440
   Width           =   5250
   Begin VB.Frame Frame7 
      Caption         =   "MIDI Channel"
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   700
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   2385
      Left            =   90
      TabIndex        =   32
      Top             =   3480
      Width           =   2415
      Begin KnobLib.Knob Knob1 
         Height          =   1935
         Left            =   120
         TabIndex        =   33
         Top             =   360
         Width           =   2175
         _Version        =   65537
         _ExtentX        =   3836
         _ExtentY        =   3413
         _StockProps     =   69
         BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         BevelWidth      =   2
         BorderWidth     =   4
         Indicator       =   0
         IndicatorColor  =   255
         IndicatorWidth  =   0
         KnobColor       =   -2147483633
         KnobStyle       =   3
         Radius          =   525
         TickCaptionColor=   0
         TickColor       =   0
         TickCount       =   16
         TickGap         =   4
         TickLength      =   6
         TickWidth       =   1
         Value           =   0
         Max             =   15
         Min             =   0
         TickCaption     =   ""
      End
   End
   Begin VB.Frame Frame6 
      Caption         =   "Channel Filtering"
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   700
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   2055
      Left            =   90
      TabIndex        =   24
      Top             =   1410
      Width           =   2415
      Begin VB.CheckBox CheckMIDIFilterChannel 
         Caption         =   "Pitch Bend"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   6
         Left            =   330
         TabIndex        =   31
         Top             =   1710
         Width           =   1605
      End
      Begin VB.CheckBox CheckMIDIFilterChannel 
         Caption         =   "Channel Pressure"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   5
         Left            =   330
         TabIndex        =   30
         Top             =   1470
         Width           =   1605
      End
      Begin VB.CheckBox CheckMIDIFilterChannel 
         Caption         =   "Note On"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   0
         Left            =   330
         TabIndex        =   29
         Top             =   270
         Width           =   1425
      End
      Begin VB.CheckBox CheckMIDIFilterChannel 
         Caption         =   "Note Off"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   1
         Left            =   330
         TabIndex        =   28
         Top             =   510
         Width           =   1425
      End
      Begin VB.CheckBox CheckMIDIFilterChannel 
         Caption         =   "Key Pressure"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   2
         Left            =   330
         TabIndex        =   27
         Top             =   750
         Width           =   1425
      End
      Begin VB.CheckBox CheckMIDIFilterChannel 
         Caption         =   "Control Change"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   3
         Left            =   330
         TabIndex        =   26
         Top             =   990
         Width           =   1425
      End
      Begin VB.CheckBox CheckMIDIFilterChannel 
         Caption         =   "Program Change"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   4
         Left            =   330
         TabIndex        =   25
         Top             =   1230
         Width           =   1605
      End
   End
   Begin VB.Frame Frame5 
      Caption         =   "Real-Time Filtering"
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   700
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   2385
      Left            =   2550
      TabIndex        =   15
      Top             =   3480
      Width           =   2415
      Begin VB.CheckBox CheckMIDIFilterReal 
         Caption         =   "MIDI Continue"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   3
         Left            =   150
         TabIndex        =   23
         Top             =   1050
         Width           =   1575
      End
      Begin VB.CheckBox CheckMIDIFilterReal 
         Caption         =   "MIDI Stop"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   4
         Left            =   150
         TabIndex        =   22
         Top             =   1290
         Width           =   1635
      End
      Begin VB.CheckBox CheckMIDIFilterReal 
         Caption         =   "Undefined"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   5
         Left            =   150
         TabIndex        =   21
         Top             =   1530
         Width           =   1425
      End
      Begin VB.CheckBox CheckMIDIFilterReal 
         Caption         =   "Active Sensing"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   6
         Left            =   150
         TabIndex        =   20
         Top             =   1770
         Width           =   1425
      End
      Begin VB.CheckBox CheckMIDIFilterReal 
         Caption         =   "System Reset"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   7
         Left            =   150
         TabIndex        =   19
         Top             =   2010
         Width           =   1425
      End
      Begin VB.CheckBox CheckMIDIFilterReal 
         Caption         =   "MIDI Clock"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   0
         Left            =   150
         TabIndex        =   18
         Top             =   330
         Width           =   1425
      End
      Begin VB.CheckBox CheckMIDIFilterReal 
         Caption         =   "Undefined"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   1
         Left            =   150
         TabIndex        =   17
         Top             =   570
         Width           =   1425
      End
      Begin VB.CheckBox CheckMIDIFilterReal 
         Caption         =   "MIDI Start"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   2
         Left            =   150
         TabIndex        =   16
         Top             =   810
         Width           =   1425
      End
   End
   Begin VB.Frame Frame4 
      Caption         =   "Queued MIDI Messages"
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   700
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   585
      Left            =   60
      TabIndex        =   7
      Top             =   750
      Width           =   4905
      Begin VB.Label LblInQueueCount 
         Alignment       =   2  'Center
         Appearance      =   0  'Flat
         BackColor       =   &H00000000&
         Caption         =   "MIDI In Queue Count"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H0000FF00&
         Height          =   225
         Left            =   90
         TabIndex        =   9
         Top             =   270
         Width           =   4755
      End
   End
   Begin VB.Frame Frame3 
      Caption         =   "MIDI Message"
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   700
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   585
      Left            =   60
      TabIndex        =   6
      Top             =   120
      Width           =   4905
      Begin VB.Label LblMidiMessage 
         Alignment       =   2  'Center
         Appearance      =   0  'Flat
         BackColor       =   &H00000000&
         Caption         =   "MIDI Message"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H0000FF00&
         Height          =   225
         Left            =   90
         TabIndex        =   8
         Top             =   270
         Width           =   4755
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "MIDI Filtering"
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   700
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   2055
      Left            =   2550
      TabIndex        =   4
      Top             =   1410
      Width           =   2415
      Begin VB.CheckBox CheckMIDIFilter 
         Caption         =   "Tune Request"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   5
         Left            =   120
         TabIndex        =   14
         Top             =   1500
         Width           =   1425
      End
      Begin VB.CheckBox CheckMIDIFilter 
         Caption         =   "Undefined xF5"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   4
         Left            =   120
         TabIndex        =   13
         Top             =   1260
         Width           =   1425
      End
      Begin VB.CheckBox CheckMIDIFilter 
         Caption         =   "Undefined xF4"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   3
         Left            =   120
         TabIndex        =   12
         Top             =   1020
         Width           =   1425
      End
      Begin VB.CheckBox CheckMIDIFilter 
         Caption         =   "Song Select"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   2
         Left            =   120
         TabIndex        =   11
         Top             =   780
         Width           =   1425
      End
      Begin VB.CheckBox CheckMIDIFilter 
         Caption         =   "Song Position Pointer"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   1
         Left            =   120
         TabIndex        =   10
         Top             =   540
         Width           =   1935
      End
      Begin VB.CheckBox CheckMIDIFilter 
         Caption         =   "MIDI Time Code"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   225
         Index           =   0
         Left            =   120
         TabIndex        =   5
         Top             =   300
         Width           =   1755
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "MIDI Out"
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   700
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   675
      Left            =   2550
      TabIndex        =   2
      Top             =   5940
      Width           =   2415
      Begin VB.ComboBox Combo1 
         Appearance      =   0  'Flat
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   700
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   300
         Left            =   120
         Style           =   2  'Dropdown List
         TabIndex        =   3
         Top             =   270
         Width           =   2205
      End
   End
   Begin VB.Frame FrameMidiIn 
      Caption         =   "MIDI In"
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   700
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   675
      Left            =   90
      TabIndex        =   0
      Top             =   5940
      Width           =   2415
      Begin VB.ComboBox Combo2 
         Appearance      =   0  'Flat
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   700
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         Height          =   300
         Left            =   120
         Style           =   2  'Dropdown List
         TabIndex        =   1
         Top             =   270
         Width           =   2205
      End
   End
   Begin MidiioLib.MIDIInput MIDIInput1 
      Left            =   720
      Top             =   6720
      _Version        =   65537
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   64
   End
   Begin MidiioLib.MIDIOutput MIDIOutput1 
      Left            =   120
      Top             =   6720
      _Version        =   65537
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   64
      DeviceID        =   0
      VolumeLeft      =   -1
      VolumeRight     =   -1
   End
End
Attribute VB_Name = "FormFilter"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

Option Explicit

'
' This FILTER example program was developed to show the types of
' MIDI message filtering that can be done with MIDI CoolTools.
'
' Remember that Channel Filtering is MIDI Channel specific.  Example:
' You could filter note off events on MIDI Channel 2, but allow them
' to not be filter on MIDI Channel 1

' MIDIInput1.Filter(NOTE_OFF + Channel1) = False
' MIDIInput1.Filter(NOTE_OFF + Channel2) = True
'
'
' Look in the MIDCONST.BAS for MIDI filtering constants
'

Private Sub CheckMIDIFilter_Click(index As Integer)

    Select Case index
        Case Is = 0
            If CheckMIDIFilter(index).Value = 0 Then
                MIDIInput1.FILTER(FILTER_MTC) = False
            Else
                MIDIInput1.FILTER(FILTER_MTC) = True
            End If
        Case Is = 1
            If CheckMIDIFilter(index).Value = 0 Then
                MIDIInput1.FILTER(FILTER_SNGPTR) = False
            Else
                MIDIInput1.FILTER(FILTER_SNGPTR) = True
            End If
        Case Is = 2
            If CheckMIDIFilter(index).Value = 0 Then
                MIDIInput1.FILTER(FILTER_SNGSEL) = False
            Else
                MIDIInput1.FILTER(FILTER_SNGSEL) = True
            End If
        Case Is = 3
            If CheckMIDIFilter(index).Value = 0 Then
                MIDIInput1.FILTER(FILTER_F4) = False
            Else
                MIDIInput1.FILTER(FILTER_F4) = True
            End If
        Case Is = 4
            If CheckMIDIFilter(index).Value = 0 Then
                MIDIInput1.FILTER(FILTER_F5) = False
            Else
                MIDIInput1.FILTER(FILTER_F5) = True
            End If
        Case Is = 5
            If CheckMIDIFilter(index).Value = 0 Then
                MIDIInput1.FILTER(FILTER_TUNE) = False
            Else
                MIDIInput1.FILTER(FILTER_TUNE) = True
            End If
    End Select
End Sub

Private Sub CheckMIDIFilter1_Click(Value As Integer)
    If Value = 0 Then
        MIDIInput1.FILTER(FILTER_F9) = False
    Else
        MIDIInput1.FILTER(FILTER_F9) = True
    End If
End Sub

Private Sub CheckMIDIFilter2_Click(Value As Integer)
    If Value = 0 Then
        MIDIInput1.FILTER(FILTER_ACTIVE_SENSE) = False
    Else
        MIDIInput1.FILTER(FILTER_ACTIVE_SENSE) = True
    End If
End Sub

Private Sub CheckMIDIFilter3_Click(Value As Integer)
    If Value = 0 Then
        MIDIInput1.FILTER(FILTER_CLOCK) = False
    Else
        MIDIInput1.FILTER(FILTER_CLOCK) = True
    End If
End Sub

Private Sub CheckMIDIFilterChannel_Click(index As Integer)
    Select Case index
        Case Is = 0
            If CheckMIDIFilterChannel(index).Value = 0 Then
                MIDIInput1.FILTER(NOTE_ON + Knob1.Value) = False
            Else
                MIDIInput1.FILTER(NOTE_ON + Knob1.Value) = True
            End If
        Case Is = 1
            If CheckMIDIFilterChannel(index).Value = 0 Then
                MIDIInput1.FILTER(NOTE_OFF + Knob1.Value) = False
            Else
                MIDIInput1.FILTER(NOTE_OFF + Knob1.Value) = True
            End If
        Case Is = 2
            If CheckMIDIFilterChannel(index).Value = 0 Then
                MIDIInput1.FILTER(POLY_KEY_PRESS + Knob1.Value) = False
            Else
                MIDIInput1.FILTER(POLY_KEY_PRESS + Knob1.Value) = True
            End If
        Case Is = 3
            If CheckMIDIFilterChannel(index).Value = 0 Then
                MIDIInput1.FILTER(CONTROLLER_CHANGE + Knob1.Value) = False
            Else
                MIDIInput1.FILTER(CONTROLLER_CHANGE + Knob1.Value) = True
            End If
        Case Is = 4
            If CheckMIDIFilterChannel(index).Value = 0 Then
                MIDIInput1.FILTER(PROGRAM_CHANGE + Knob1.Value) = False
            Else
                MIDIInput1.FILTER(PROGRAM_CHANGE + Knob1.Value) = True
            End If
        Case Is = 5
            If CheckMIDIFilterChannel(index).Value = 0 Then
                MIDIInput1.FILTER(CHANNEL_PRESSURE + Knob1.Value) = False
            Else
                MIDIInput1.FILTER(CHANNEL_PRESSURE + Knob1.Value) = True
            End If
        Case Is = 6
            If CheckMIDIFilterChannel(index).Value = 0 Then
                MIDIInput1.FILTER(PITCH_BEND + Knob1.Value) = False
            Else
                MIDIInput1.FILTER(PITCH_BEND + Knob1.Value) = True
            End If
    End Select
End Sub

Private Sub CheckMIDIFilterReal_Click(index As Integer)
    Select Case index
        Case Is = 0
            If CheckMIDIFilterReal(index).Value = 0 Then
                MIDIInput1.FILTER(FILTER_CLOCK) = False
            Else
                MIDIInput1.FILTER(FILTER_CLOCK) = True
            End If
        Case Is = 1
            If CheckMIDIFilterReal(index).Value = 0 Then
                MIDIInput1.FILTER(FILTER_F9) = False
            Else
                MIDIInput1.FILTER(FILTER_F9) = True
            End If
        Case Is = 2
            If CheckMIDIFilterReal(index).Value = 0 Then
                MIDIInput1.FILTER(FILTER_START) = False
            Else
                MIDIInput1.FILTER(FILTER_START) = True
            End If
        Case Is = 3
            If CheckMIDIFilterReal(index).Value = 0 Then
                MIDIInput1.FILTER(FILTER_CONT) = False
            Else
                MIDIInput1.FILTER(FILTER_CONT) = True
            End If
        Case Is = 4
            If CheckMIDIFilterReal(index).Value = 0 Then
                MIDIInput1.FILTER(FILTER_STOP) = False
            Else
                MIDIInput1.FILTER(FILTER_STOP) = True
            End If
        Case Is = 5
            If CheckMIDIFilterReal(index).Value = 0 Then
                MIDIInput1.FILTER(FILTER_FD) = False
            Else
                MIDIInput1.FILTER(FILTER_FD) = True
            End If
        Case Is = 6
            If CheckMIDIFilterReal(index).Value = 0 Then
                MIDIInput1.FILTER(FILTER_ACTIVE_SENSE) = False
            Else
                MIDIInput1.FILTER(FILTER_ACTIVE_SENSE) = True
            End If
        Case Is = 7
            If CheckMIDIFilterReal(index).Value = 0 Then
                MIDIInput1.FILTER(FILTER_RESET) = False
            Else
                MIDIInput1.FILTER(FILTER_RESET) = True
            End If
    End Select
End Sub

Private Sub Combo1_Click()
    Dim wRtn As Integer

    
    ' Close
    MIDIOutput1.Action = MIDIOUT_CLOSE
    
    ' Open selected device
    MIDIOutput1.DeviceID = Combo1.ListIndex - 1
    MIDIOutput1.Action = MIDIOUT_OPEN
End Sub

Private Sub Combo2_Click()
    Dim wRtn As Integer
    
    If MIDIInput1.State >= MIDISTATE_OPEN Then
        ' Close midiin port
        MIDIInput1.Action = MIDIIN_CLOSE
    End If

    
    ' Get selected device id
    MIDIInput1.DeviceID = Combo2.ListIndex
    
    ' Open and display handle
    MIDIInput1.Action = MIDIIN_OPEN
    MIDIInput1.Action = MIDIIN_START
End Sub

Private Sub Form_Load()
    Dim i As Integer

    For i = 0 To 15
        Knob1.TickCaption(i) = (i + 1)
        Next i

    ' Center the form on the screen
    Move (Screen.Width - Width) \ 2, (Screen.Height - Height) \ 2

    '
    ' Fill output device combo box
    '
    For i = -1 To MIDIOutput1.DeviceCount - 1
        MIDIOutput1.DeviceID = i
        Combo1.AddItem MIDIOutput1.ProductName
        Next
    '
    ' Select first in list
    '
    Combo1.ListIndex = 0
    MIDIOutput1.DeviceID = -1
    '
    ' Fill input device combo box
    '
    For i = 0 To MIDIInput1.DeviceCount - 1
        MIDIInput1.DeviceID = i
        Combo2.AddItem MIDIInput1.ProductName
        Next
    '
    ' Select first in list
    '
    Combo2.ListIndex = 0
    MIDIInput1.DeviceID = 0
End Sub

Private Sub Form_Unload(Cancel As Integer)
    MIDIInput1.Action = MIDIIN_STOP
    
    ' Close midiin port
    MIDIInput1.Action = MIDIIN_CLOSE
    
    ' Close
    MIDIOutput1.Action = MIDIOUT_CLOSE
End Sub

Private Sub Knob1_Change()
Dim index As Integer
    
    '
    'Turn off all Filter on this channel
    '
    For index = 0 To 6
        CheckMIDIFilterChannel(index).Value = 0
        MIDIInput1.FILTER(NOTE_ON + Knob1.Value) = False
        MIDIInput1.FILTER(NOTE_OFF + Knob1.Value) = False
        MIDIInput1.FILTER(POLY_KEY_PRESS + Knob1.Value) = False
        MIDIInput1.FILTER(CONTROLLER_CHANGE + Knob1.Value) = False
        MIDIInput1.FILTER(PROGRAM_CHANGE + Knob1.Value) = False
        MIDIInput1.FILTER(CHANNEL_PRESSURE + Knob1.Value) = False
        MIDIInput1.FILTER(PITCH_BEND + Knob1.Value) = False
    Next
End Sub

Private Sub MIDIInput1_Error(ErrorCode As Integer, ErrorMessage As String)
    '
    ' Midi input error, display message
    '
   If (ErrorCode <> 0) and (ErrorCode <> 8) Then
      MsgBox ErrorMessage
      End If

End Sub

Private Sub MIDIInput1_Message()
    '
    ' Show incoming data on screen
    ' Labels in VB 3.0 are very slow in updating/repainting,
    ' at least in terms of real-time.  If you using a label REFRESH
    ' method you will experience some time delay.
    '
    ' Generally, painting of a label control is handled automatically
    ' by VB while no events are occurring.  So if you try to force
    ' VB to repaint a label control immediately, you will be taking
    '
    LblMidiMessage.Caption = Str(MIDIInput1.Message) & Str(MIDIInput1.Data1) & Str(MIDIInput1.Data2)

    '
    'This do while loop allows you to take all the messages that are
    'waiting in the message queue.
    '
    Do While MIDIInput1.MessageCount > 0
        '
        'This is the incoming MIDI data
        '
        MIDIOutput1.Message = MIDIInput1.Message
        MIDIOutput1.Data1 = MIDIInput1.Data1
        MIDIOutput1.Data2 = MIDIInput1.Data2
        MIDIOutput1.Time = 0

        '
        ' Display number of queued MIDI In messages
        '
        LblInQueueCount.Caption = MIDIInput1.MessageCount
        LblInQueueCount.Refresh

        
        '
        'Send MIDI Data
        '
        MIDIOutput1.Action = MIDIOUT_SEND
        '
        'Remove the MIDI data from the MIDI IN queue
        '
        MIDIInput1.Action = MIDIIN_REMOVE
    Loop
End Sub

Private Sub MIDIOutput1_Error(ErrorCode As Integer, ErrorMessage As String)
    '
    ' Midi output error, display message
    '
   If (ErrorCode <> 0) and (ErrorCode <> 8) Then
      MsgBox ErrorMessage
      End If
End Sub

Private Sub MIDIOutput1_QueueEmpty()
    '
    'Once queue becomes empty, get ready to record again
    '
    MIDIOutput1.Action = MIDIOUT_STOP
End Sub

