' NoteRepeat used to stop the same key from repeating.  CapsLock detects if it is down.
Global NoteRepeat As Integer

Global Const MODAL = 1

' The Patch number array used for current patch for each midi channel
' Then Volume array used for each channels volume setting
' TrackChannel is array for the current midi channel that that Track on the mixi is set to.
Global MidiPatch(TOTAL_MIDI_CHANNELS) As Integer
Global MidiVolume(TOTAL_MIDI_CHANNELS) As Integer
Global TrackChannel(TOTAL_MIDI_CHANNELS) As Integer
Global MidiPan(TOTAL_MIDI_CHANNELS) As Integer
Global Octave(TOTAL_MIDI_CHANNELS) As Integer

' The current Midi Channel out set on Piano form
Global MidiChannelOut As Integer

' The Velocity (Volume) of notes for current midi channel
Global MidiVelocity As Integer

Sub MIDIInOpen ()
    Dim wRtn As Integer
    
    If frmMain.MIDIInput1.State >= MIDISTATE_OPEN Then
	' Close midiin port
	frmMain.MIDIInput1.Action = MIDIIN_CLOSE
    End If

    
    ' Get selected device id
    frmMain.MIDIInput1.DeviceID = MIDISetupForm.ComboMidiIn.ListIndex
    
    ' Open and display handle
    frmMain.MIDIInput1.Action = MIDIIN_OPEN

    ' Start midi input
    frmMain.MIDIInput1.Action = MIDIIN_START
    
    note = 0
End Sub

Sub MIDIOutOpen ()

    If frmMain.MIDIOutput1.State >= MIDISTATE_OPEN Or frmMain.MIDIOutput1.DeviceID = -1 Then
	' Close
	frmMain.MIDIOutput1.Action = MIDIOUT_CLOSE
    End If
    

    ' Open selected device
    frmMain.MIDIOutput1.DeviceID = MIDISetupForm.ComboMidiOut.ListIndex - 1
    frmMain.MIDIOutput1.Action = MIDIOUT_OPEN
    
    '
    ' Return buttons and variables to preplay state
    '
End Sub

