VERSION 4.00
Begin VB.Form frmMain 
   Appearance      =   0  'Flat
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   0  'None
   Caption         =   "MIDI CoolTools - Piano"
   ClientHeight    =   1830
   ClientLeft      =   1140
   ClientTop       =   2190
   ClientWidth     =   9330
   BeginProperty Font 
      name            =   "MS Sans Serif"
      charset         =   0
      weight          =   700
      size            =   8.25
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   2520
   Icon            =   "PIANO2.frx":0000
   Left            =   1080
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   1830
   ScaleWidth      =   9330
   Top             =   1560
   Width           =   9450
   Begin VB.Frame Frame1 
      Height          =   915
      Left            =   -30
      TabIndex        =   74
      Top             =   0
      Width           =   9375
      Begin VB.ComboBox ComboPatch 
         Appearance      =   0  'Flat
         BackColor       =   &H00000000&
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   8.25
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H0000FF00&
         Height          =   300
         Left            =   5460
         Style           =   2  'Dropdown List
         TabIndex        =   71
         Top             =   510
         Width           =   2295
      End
      Begin KnobLib.Knob KnobPan 
         Height          =   600
         Left            =   8160
         TabIndex        =   79
         Top             =   300
         Width           =   855
         _Version        =   65537
         _ExtentX        =   1508
         _ExtentY        =   1058
         _StockProps     =   69
         BackColor       =   -2147483633
         BevelWidth      =   2
         BorderWidth     =   0
         Indicator       =   1
         IndicatorColor  =   255
         IndicatorWidth  =   0
         KnobColor       =   12632256
         KnobStyle       =   3
         Radius          =   240
         TickCaptionColor=   0
         TickColor       =   0
         TickCount       =   0
         TickGap         =   1
         TickLength      =   4
         TickWidth       =   1
         Value           =   1
         Max             =   127
         Min             =   0
         TickCaption     =   ""
      End
      Begin HslideLib.HSlider HSliderOctave 
         Height          =   315
         Left            =   3960
         TabIndex        =   78
         Top             =   570
         Width           =   1185
         _Version        =   65537
         _ExtentX        =   2090
         _ExtentY        =   556
         _StockProps     =   65
         BackColor       =   -2147483633
         BevelInner      =   0
         BevelOuter      =   0
         BevelWidth      =   1
         BorderWidth     =   1
         Gap             =   3
         LargeChange     =   2
         ThumbHeight     =   300
         ThumbStyle      =   1
         ThumbWidth      =   200
         TickColor       =   0
         TickCount       =   4
         TickLength      =   4
         TickMarks       =   1
         TickWidth       =   1
         TrackBevel      =   1
         TrackWidth      =   3
         Value           =   1
         Max             =   3
         Min             =   0
      End
      Begin HslideLib.HSlider HSliderVolume 
         Height          =   315
         Left            =   2160
         TabIndex        =   77
         Top             =   570
         Width           =   1275
         _Version        =   65537
         _ExtentX        =   2249
         _ExtentY        =   556
         _StockProps     =   65
         BackColor       =   -2147483633
         BevelInner      =   0
         BevelOuter      =   0
         BevelWidth      =   1
         BorderWidth     =   1
         Gap             =   3
         LargeChange     =   2
         ThumbHeight     =   245
         ThumbStyle      =   3
         ThumbWidth      =   320
         TickColor       =   0
         TickCount       =   5
         TickLength      =   4
         TickMarks       =   0
         TickWidth       =   1
         TrackBevel      =   1
         TrackWidth      =   3
         Value           =   1
         Max             =   127
         Min             =   0
      End
      Begin HslideLib.HSlider HSliderMIDIChannel 
         Height          =   315
         Left            =   90
         TabIndex        =   76
         Top             =   570
         Width           =   1665
         _Version        =   65537
         _ExtentX        =   2937
         _ExtentY        =   556
         _StockProps     =   65
         BackColor       =   -2147483633
         BevelInner      =   0
         BevelOuter      =   0
         BevelWidth      =   1
         BorderWidth     =   3
         Gap             =   3
         LargeChange     =   2
         ThumbHeight     =   245
         ThumbStyle      =   1
         ThumbWidth      =   200
         TickColor       =   0
         TickCount       =   16
         TickLength      =   4
         TickMarks       =   1
         TickWidth       =   1
         TrackBevel      =   1
         TrackWidth      =   3
         Value           =   1
         Max             =   15
         Min             =   0
      End
      Begin VB.Label Label5 
         Caption         =   "L - Pan - R"
         Height          =   255
         Left            =   8130
         TabIndex        =   75
         Top             =   120
         Width           =   1005
      End
      Begin VB.Label MidiChannelOutLabel 
         Alignment       =   2  'Center
         Appearance      =   0  'Flat
         BackColor       =   &H00000000&
         Caption         =   "1"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   9.75
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H0000FF00&
         Height          =   255
         Left            =   1350
         TabIndex        =   66
         Top             =   270
         Width           =   405
      End
      Begin VB.Label Label1 
         Caption         =   "MIDI Channel"
         Height          =   255
         Left            =   120
         TabIndex        =   67
         Top             =   270
         Width           =   1215
      End
      Begin VB.Label Label2 
         Caption         =   "Volume"
         Height          =   255
         Left            =   2160
         TabIndex        =   68
         Top             =   270
         Width           =   675
      End
      Begin VB.Label Label3 
         Caption         =   "Octave"
         Height          =   255
         Left            =   3930
         TabIndex        =   69
         Top             =   270
         Width           =   645
      End
      Begin VB.Label LabelVolume 
         Alignment       =   2  'Center
         Appearance      =   0  'Flat
         BackColor       =   &H00000000&
         Caption         =   "100"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   9.75
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H0000FF00&
         Height          =   255
         Left            =   2820
         TabIndex        =   70
         Top             =   270
         Width           =   585
      End
      Begin VB.Label Label4 
         Caption         =   "Patch"
         Height          =   255
         Left            =   5460
         TabIndex        =   72
         Top             =   270
         Width           =   645
      End
      Begin VB.Label LabelOctave 
         Alignment       =   2  'Center
         Appearance      =   0  'Flat
         BackColor       =   &H00000000&
         Caption         =   "0"
         BeginProperty Font 
            name            =   "MS Sans Serif"
            charset         =   0
            weight          =   400
            size            =   9.75
            underline       =   0   'False
            italic          =   0   'False
            strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H0000FF00&
         Height          =   255
         Left            =   4560
         TabIndex        =   73
         Top             =   270
         Width           =   405
      End
   End
   Begin Threed.SSPanel Panel3D3 
      Height          =   975
      Left            =   0
      TabIndex        =   0
      Top             =   900
      Width           =   9315
      _Version        =   65536
      _ExtentX        =   16431
      _ExtentY        =   1720
      _StockProps     =   15
      ForeColor       =   8421504
      BackColor       =   -2147483633
      BevelWidth      =   3
      BorderWidth     =   0
      Outline         =   -1  'True
      Alignment       =   6
      Autosize        =   3
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":030A
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   61
         Left            =   8640
         TabIndex        =   62
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":0614
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   63
         Left            =   8910
         TabIndex        =   61
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":091E
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   1
         Left            =   240
         TabIndex        =   53
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":0C28
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   3
         Left            =   480
         TabIndex        =   52
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":0F32
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   6
         Left            =   960
         TabIndex        =   51
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":123C
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   8
         Left            =   1200
         TabIndex        =   50
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":1546
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   10
         Left            =   1440
         TabIndex        =   49
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":1850
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   13
         Left            =   1920
         TabIndex        =   20
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":1B5A
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   15
         Left            =   2160
         TabIndex        =   19
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":1E64
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   20
         Left            =   2880
         TabIndex        =   18
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":216E
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   22
         Left            =   3120
         TabIndex        =   17
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":2478
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   25
         Left            =   3600
         TabIndex        =   16
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":2782
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   27
         Left            =   3840
         TabIndex        =   15
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":2A8C
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   32
         Left            =   4560
         TabIndex        =   14
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":2D96
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   34
         Left            =   4800
         TabIndex        =   13
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":30A0
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   37
         Left            =   5280
         TabIndex        =   12
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":33AA
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   39
         Left            =   5520
         TabIndex        =   11
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":36B4
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   44
         Left            =   6240
         TabIndex        =   10
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":39BE
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   46
         Left            =   6480
         TabIndex        =   9
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":3CC8
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   49
         Left            =   6960
         TabIndex        =   8
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":3FD2
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   51
         Left            =   7200
         TabIndex        =   7
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":42DC
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   56
         Left            =   7920
         TabIndex        =   6
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":45E6
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   58
         Left            =   8160
         TabIndex        =   5
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":48F0
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   18
         Left            =   2640
         TabIndex        =   4
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":4BFA
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   30
         Left            =   4320
         TabIndex        =   3
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":4F04
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   42
         Left            =   6000
         TabIndex        =   2
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":520E
         DragMode        =   1  'Automatic
         Height          =   585
         Index           =   54
         Left            =   7680
         TabIndex        =   1
         Top             =   90
         Width           =   165
         _Version        =   65536
         _ExtentX        =   291
         _ExtentY        =   1032
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   0
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":5518
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   60
         Left            =   8490
         TabIndex        =   65
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":5822
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   62
         Left            =   8730
         TabIndex        =   64
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":5B2C
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   64
         Left            =   8970
         TabIndex        =   63
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":5E36
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   7
         Left            =   1050
         TabIndex        =   60
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":6140
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   9
         Left            =   1290
         TabIndex        =   59
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":644A
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   11
         Left            =   1530
         TabIndex        =   58
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":6754
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   4
         Left            =   570
         TabIndex        =   57
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":6A5E
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   5
         Left            =   810
         TabIndex        =   56
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":6D68
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   2
         Left            =   330
         TabIndex        =   55
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":7072
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   0
         Left            =   90
         TabIndex        =   54
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":737C
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   12
         Left            =   1770
         TabIndex        =   48
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":7686
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   14
         Left            =   2010
         TabIndex        =   47
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":7990
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   16
         Left            =   2250
         TabIndex        =   46
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":7C9A
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   17
         Left            =   2490
         TabIndex        =   45
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":7FA4
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   19
         Left            =   2730
         TabIndex        =   44
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":82AE
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   21
         Left            =   2970
         TabIndex        =   43
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":85B8
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   23
         Left            =   3210
         TabIndex        =   42
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":88C2
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   24
         Left            =   3450
         TabIndex        =   41
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":8BCC
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   26
         Left            =   3690
         TabIndex        =   40
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":8ED6
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   28
         Left            =   3930
         TabIndex        =   39
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":91E0
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   29
         Left            =   4170
         TabIndex        =   38
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":94EA
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   31
         Left            =   4410
         TabIndex        =   37
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":97F4
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   33
         Left            =   4650
         TabIndex        =   36
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":9AFE
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   35
         Left            =   4890
         TabIndex        =   35
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":9E08
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   36
         Left            =   5130
         TabIndex        =   34
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":A112
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   38
         Left            =   5370
         TabIndex        =   33
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":A41C
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   40
         Left            =   5610
         TabIndex        =   32
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":A726
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   41
         Left            =   5850
         TabIndex        =   31
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":AA30
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   43
         Left            =   6090
         TabIndex        =   30
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":AD3A
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   45
         Left            =   6330
         TabIndex        =   29
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":B044
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   47
         Left            =   6570
         TabIndex        =   28
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":B34E
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   48
         Left            =   6810
         TabIndex        =   27
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":B658
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   50
         Left            =   7050
         TabIndex        =   26
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":B962
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   52
         Left            =   7290
         TabIndex        =   25
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":BC6C
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   53
         Left            =   7530
         TabIndex        =   24
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":BF76
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   55
         Left            =   7770
         TabIndex        =   23
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":C280
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   57
         Left            =   8010
         TabIndex        =   22
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
      Begin Threed.SSPanel PanelWhite 
         DragIcon        =   "PIANO2.frx":C58A
         DragMode        =   1  'Automatic
         Height          =   855
         Index           =   59
         Left            =   8250
         TabIndex        =   21
         Top             =   90
         Width           =   255
         _Version        =   65536
         _ExtentX        =   450
         _ExtentY        =   1508
         _StockProps     =   15
         ForeColor       =   8421504
         BackColor       =   16777215
         BevelWidth      =   2
         BorderWidth     =   2
         Outline         =   -1  'True
         Alignment       =   6
         Autosize        =   3
      End
   End
   Begin MidiioLib.MIDIOutput MIDIOutput1 
      Left            =   600
      Top             =   1920
      _Version        =   65537
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      DeviceID        =   0
      VolumeLeft      =   -1
      VolumeRight     =   -1
   End
   Begin MidiioLib.MIDIInput MIDIInput1 
      Left            =   120
      Top             =   1920
      _Version        =   65537
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
   End
   Begin VB.Menu File 
      Caption         =   "&File"
      Begin VB.Menu Exit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu MIDI 
      Caption         =   "&MIDI"
      Begin VB.Menu MIDISetup 
         Caption         =   "MIDI &Setup"
      End
   End
   Begin VB.Menu help 
      Caption         =   "&Help"
      Begin VB.Menu About 
         Caption         =   "&About"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Dim NoteCatchCount As Integer
Dim NoteOnCatcher(1024) As Integer

'
' While recording this variable contains the recording
' start time
'
Dim startTime As Long

'
' Index into notes array
'
Dim note As Integer
'


Private Sub ComboPatch_Click()
    ' Sets the Patch for the current Midi Channel Out
    MidiPatch(MidiChannelOut) = ComboPatch.ListIndex

    'Patch Midi Out routine
    MIDIOutput1.Message = PROGRAM_CHANGE + MidiChannelOut
    MIDIOutput1.Data1 = MidiPatch(MidiChannelOut)
    MIDIOutput1.Data2 = 0
    MIDIOutput1.Time = 0
    MIDIOutput1.Action = MIDIOUT_SEND
End Sub

Private Sub Exit_Click()
    ' Stop the MIDI In
    MIDIInput1.Action = MIDIIN_STOP
    
    ' Close MIDI In
    MIDIInput1.Action = MIDIIN_CLOSE

    
    ' Close MIDI Out
    MIDIOutput1.Action = MIDIOUT_CLOSE

    End
End Sub

Private Sub Form_Load()
    Screen.MousePointer = 11
    frmMain.Left = 0
    frmMain.Top = 0
    
    ' General MIDI patches
    ComboPatch.AddItem "Acoustic Grand Piano"
    ComboPatch.AddItem "Bright Acoustic Piano"
    ComboPatch.AddItem "Electric Grand Piano"
    ComboPatch.AddItem "Honkytonk Piano"
    ComboPatch.AddItem "Rhodes Piano"
    ComboPatch.AddItem "Chorus Piano"
    ComboPatch.AddItem "Harpsichord"
    ComboPatch.AddItem "Clavinet"
    ComboPatch.AddItem "Celesta"
    ComboPatch.AddItem "Glockenspiel"
    ComboPatch.AddItem "Music Box"
    ComboPatch.AddItem "Vibraphone"
    ComboPatch.AddItem "Marimba"
    ComboPatch.AddItem "Xylophone"
    ComboPatch.AddItem "Tubular Bells"
    ComboPatch.AddItem "Dulcimer"
    ComboPatch.AddItem "Hammond Organ"
    ComboPatch.AddItem "Percuss. Organ"
    ComboPatch.AddItem "Rock Organ"
    ComboPatch.AddItem "Church Organ"
    ComboPatch.AddItem "Reed Organ"
    ComboPatch.AddItem "Accordion"
    ComboPatch.AddItem "Harmonica"
    ComboPatch.AddItem "Tango Accordion"
    ComboPatch.AddItem "Acoustic Guitar (nylon)"
    ComboPatch.AddItem "Acoustic Guitar (steel)"
    ComboPatch.AddItem "Electric Guitar (jazz)"
    ComboPatch.AddItem "Electric Guitar (clean)"
    ComboPatch.AddItem "Electric Guitar (muted)"
    ComboPatch.AddItem "Overdriven Guitar"
    ComboPatch.AddItem "Distortion Guitar"
    ComboPatch.AddItem "Guitar Harmonics"
    ComboPatch.AddItem "Acoustic Bass"
    ComboPatch.AddItem "Electric Bass (finger)"
    ComboPatch.AddItem "Electric Bass (pick)"
    ComboPatch.AddItem "Fretless Bass"
    ComboPatch.AddItem "Slap Bass 1"
    ComboPatch.AddItem "Slap Bass 2"
    ComboPatch.AddItem "Synth Bass 1"
    ComboPatch.AddItem "Synth Bass 2"
    ComboPatch.AddItem "Violin"
    ComboPatch.AddItem "Viola"
    ComboPatch.AddItem "Cello"
    ComboPatch.AddItem "Contra Bass"
    ComboPatch.AddItem "Tremolo Strings"
    ComboPatch.AddItem "Pizzicato Strings"
    ComboPatch.AddItem "Orchestral Harp"
    ComboPatch.AddItem "Timpani"
    ComboPatch.AddItem "String Ensemble 1"
    ComboPatch.AddItem "String Ensemble 2"
    ComboPatch.AddItem "Synth Strings 1"
    ComboPatch.AddItem "Synth Strings 2"
    ComboPatch.AddItem "Choir Aahs"
    ComboPatch.AddItem "Voice Oohs"
    ComboPatch.AddItem "Synth Voice"
    ComboPatch.AddItem "Orchestra Hit"
    ComboPatch.AddItem "Trumpet"
    ComboPatch.AddItem "Trombone"
    ComboPatch.AddItem "Tuba"
    ComboPatch.AddItem "Muted Trumpet"
    ComboPatch.AddItem "French Horn"
    ComboPatch.AddItem "Brass Section"
    ComboPatch.AddItem "Synth Brass 1"
    ComboPatch.AddItem "Synth Brass 2"
    ComboPatch.AddItem "Soprano Sax"
    ComboPatch.AddItem "Alto Sax"
    ComboPatch.AddItem "Tenor Sax"
    ComboPatch.AddItem "Baritone Sax"
    ComboPatch.AddItem "Oboe"
    ComboPatch.AddItem "English Horn"
    ComboPatch.AddItem "Bassoon"
    ComboPatch.AddItem "Clarinet"
    ComboPatch.AddItem "Piccolo"
    ComboPatch.AddItem "Flute"
    ComboPatch.AddItem "Recorder"
    ComboPatch.AddItem "Pan Flute"
    ComboPatch.AddItem "Bottle Blow"
    ComboPatch.AddItem "Shaku"
    ComboPatch.AddItem "Whistle"
    ComboPatch.AddItem "Ocarina"
    ComboPatch.AddItem "Lead 1 (square)"
    ComboPatch.AddItem "Lead 2 (saw tooth)"
    ComboPatch.AddItem "Lead 3 (calliope lead)"
    ComboPatch.AddItem "Lead 4 (chiff lead)"
    ComboPatch.AddItem "Lead 5 (charang)"
    ComboPatch.AddItem "Lead 6 (voice)"
    ComboPatch.AddItem "Lead 7 (fifths)"
    ComboPatch.AddItem "Lead 8 (bass + lead)"
    ComboPatch.AddItem "Pad 1 (new age)"
    ComboPatch.AddItem "Pad 2 (warm)"
    ComboPatch.AddItem "Pad 3 (poly synth)"
    ComboPatch.AddItem "Pad 4 (choir)"
    ComboPatch.AddItem "Pad 5 (bowed)"
    ComboPatch.AddItem "Pad 6 (metallic)"
    ComboPatch.AddItem "Pad 7 (halo)"
    ComboPatch.AddItem "Pad 8 (sweep)"
    ComboPatch.AddItem "FX 1 (rain)"
    ComboPatch.AddItem "FX 2 (sound track)"
    ComboPatch.AddItem "FX 3 (crystal)"
    ComboPatch.AddItem "FX 4 (atmo - sphere)"
    ComboPatch.AddItem "FX 5 (bright)"
    ComboPatch.AddItem "FX 6 (goblins)"
    ComboPatch.AddItem "FX 7 (echoes)"
    ComboPatch.AddItem "FX 8 (sci-fi)"
    ComboPatch.AddItem "Sitar"
    ComboPatch.AddItem "Banjo"
    ComboPatch.AddItem "Shamisen"
    ComboPatch.AddItem "Koto"
    ComboPatch.AddItem "Kalimba"
    ComboPatch.AddItem "Bagpipe"
    ComboPatch.AddItem "Fiddle"
    ComboPatch.AddItem "Shanai"
    ComboPatch.AddItem "Tinkle Bell"
    ComboPatch.AddItem "Agogo"
    ComboPatch.AddItem "Steel Drums"
    ComboPatch.AddItem "Wood block"
    ComboPatch.AddItem "Taiko Drum"
    ComboPatch.AddItem "Melodic Tom"
    ComboPatch.AddItem "Synth Drum"
    ComboPatch.AddItem "Reverse Cymbal"
    ComboPatch.AddItem "Guitar Fret Noise"
    ComboPatch.AddItem "Breath Noise"
    ComboPatch.AddItem "Seashore"
    ComboPatch.AddItem "Bird Tweet"
    ComboPatch.AddItem "Telephone Ring"
    ComboPatch.AddItem "Helicopter"
    ComboPatch.AddItem "Applause"
    ComboPatch.AddItem "Gunshot"
    ComboPatch.ListIndex = 0

    MidiChannelOut = 0
    HSliderMIDIChannel.Value = 0
    HSliderOctave.Value = 3
    HSliderVolume.Value = 100
    KnobPan.Value = 64

    Screen.MousePointer = 0
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' Stop the MIDI In
    MIDIInput1.Action = MIDIIN_STOP
    
    ' Close MIDI In
    MIDIInput1.Action = MIDIIN_CLOSE

    
    ' Close MIDI Out
    MIDIOutput1.Action = MIDIOUT_CLOSE

    End
End Sub

Private Sub HSliderMIDIChannel_Change()
    ' Change Midi Channel to Vscroll1 value
    MidiChannelOut = HSliderMIDIChannel.Value

    ' Display new channel
    MidiChannelOutLabel.Caption = Str$(MidiChannelOut + 1)

    ' Sets the Patch & Volume for the current Midi Channel Out
    ComboPatch.ListIndex = MidiPatch(MidiChannelOut)
    HSliderVolume.Value = MidiVolume(MidiChannelOut)
    KnobPan.Value = MidiPan(MidiChannelOut)
    HSliderOctave.Value = Octave(MidiChannelOut) / 12
End Sub

Private Sub HSliderMIDIChannel_Scroll()
    ' Change Midi Channel to Vscroll1 value
    MidiChannelOut = HSliderMIDIChannel.Value

    ' Display new channel
    MidiChannelOutLabel.Caption = Str$(MidiChannelOut + 1)

    ' Sets the Patch & Volume for the current Midi Channel Out
    ComboPatch.ListIndex = MidiPatch(MidiChannelOut)
    HSliderVolume.Value = MidiVolume(MidiChannelOut)
    KnobPan.Value = MidiPan(MidiChannelOut)
    HSliderOctave.Value = Octave(MidiChannelOut) / 12

End Sub

Private Sub HSliderOctave_Change()
    LabelOctave.Caption = Str$(HSliderOctave.Value)
    Octave(MidiChannelOut) = (HSliderOctave.Value * 12)
End Sub

Private Sub HSliderOctave_Scroll()
    LabelOctave.Caption = Str$(HSliderOctave.Value)
    Octave(MidiChannelOut) = (HSliderOctave.Value * 12)
End Sub

Private Sub HSliderVolume_Change()
    MidiVelocity = HSliderVolume.Value
    MidiVolume(MidiChannelOut) = HSliderVolume.Value
    LabelVolume.Caption = Str$(MidiVelocity)
End Sub

Private Sub HSliderVolume_Scroll()
    MidiVelocity = HSliderVolume.Value
    MidiVolume(MidiChannelOut) = HSliderVolume.Value
    LabelVolume.Caption = Str$(MidiVelocity)
End Sub

Private Sub KnobPan_Change()
    MidiPan(MidiChannelOut) = KnobPan.Value

    'Pan Midi Out routine
    MIDIOutput1.Message = CONTROLLER_CHANGE + MidiChannelOut
    MIDIOutput1.Data1 = PAN
    MIDIOutput1.Data2 = MidiPan(MidiChannelOut)
    MIDIOutput1.Time = 0
    MIDIOutput1.Action = MIDIOUT_SEND
End Sub

Private Sub KnobPan_Scroll()
    MidiPan(MidiChannelOut) = KnobPan.Value

    'Pan Midi Out routine
    MIDIOutput1.Message = CONTROLLER_CHANGE + MidiChannelOut
    MIDIOutput1.Data1 = PAN
    MIDIOutput1.Data2 = MidiPan(MidiChannelOut)
    MIDIOutput1.Time = 0
    MIDIOutput1.Action = MIDIOUT_SEND
End Sub

Private Sub MIDIInput1_Error(ErrorCode As Integer, ErrorMessage As String)
   If (ErrorCode <> 0) and (ErrorCode <> 8) Then
      MsgBox ErrorMessage
      End If
End Sub

Private Sub MIDIInput1_Message()
    Dim InMessage As Integer
    Dim InData1 As Integer
    Dim InData2 As Integer

    '
    ' The MIDI1.VBX will receive and time stamp in-coming MIDI data very
    ' fast, but it takes VB a lot of time to fire this Message event. If
    ' you need to process MIDI data in real-time, each time this Message
    ' event fires, you should take all the pending messages.  One way to
    ' do this is by using a Do While MIDIInput2.MessageCount > 0
    ' This do while loop allows you to take all the messages that are
    ' waiting in the message queue.

    Do While MIDIInput1.MessageCount > 0
        '
        'This is in-coming MIDI data
        '
        InMessage = MIDIInput1.Message
        InData1 = MIDIInput1.Data1
        InData2 = MIDIInput1.Data2

        '
        'Now we are going to prepare the MIDI data that just came in to
        'be ready to go right back out the MIDI OUT
        '
        MIDIOutput1.Message = InMessage
        MIDIOutput1.Data1 = InData1
        MIDIOutput1.Data2 = InData2
        
        Select Case InMessage
        '
        ' NOTE_ON, NOTE_OFF, PROGRAM_CHANGE, TOTAL_MIDI_CHANNELS
        ' are all constants from the MIDCONST.BAS file.  Using constants in
        ' the MIDCONST.BAS file will allow you to not have to work with
        ' confusing codes.
        '
        ' Check to see if the in-coming MIDI Message was a NOTE_ON from the
        ' currently selected MIDI channel.
        '
        ' We can only display 64 notes on our graphic piano.  Check to see if
        ' InData1 (which is the actual MIDI note be played) can be shown on
        ' the graphic piano display.
        '
        ' Using HSliderOctave, the Octave(MidiChannelOut) is set.  This
        ' allows you to slide the octave display up and down for disaply
        ' notes that would otherwise not be able to appear on the graphic
        ' piano display.
        '
           Case NOTE_ON + MidiChannelOut
                If InData1 <= 64 + Octave(MidiChannelOut) Then
                    '
                    ' Some MIDI manufactures turn MIDI notes off by sending a MIDI NOTE ON
                    ' with a velocity = 0.  InData2 is the note velocity.  If it is greater
                    ' than 0 then it truly is a note on.  If it is, then push down the
                    ' graphic key on the piano.
                    '
                    ' If InData2 is equal to zero, then release the graphic key on the piano
                    ' because it is actually a note off.
                    '
                    If InData2 > 0 Then
                        '
                        ' Push down the graphic key on the piano
                        '
                        frmMain.PanelWhite(InData1 - Octave(MidiChannelOut)).BevelOuter = 0
                    Else
                        ' Release the graphic key on the piano
                        '
                        frmMain.PanelWhite(InData1 - Octave(MidiChannelOut)).BevelOuter = 2
                    End If
                End If
                '
                'Tell MIDIOutput1 to send the MIDI data
                '
                MIDIOutput1.Action = MIDIOUT_SEND

            '
            ' MIDI NOTE OFF Event received
            '
            Case NOTE_OFF + MidiChannelOut
                If InData1 <= 64 + Octave(MidiChannelOut) Then
                    '
                    ' Release the graphic key on the piano
                    '
                    frmMain.PanelWhite(InData1 - Octave(MidiChannelOut)).BevelOuter = 2
                End If
                '
                'Tell MIDIOutput1 to send the MIDI data
                '
                MIDIOutput1.Action = MIDIOUT_SEND

            '
            ' Patch Program Change received
            '
            Case PROGRAM_CHANGE + MidiChannelOut
                '
                ' Patches (organ, piano, horn, etc.) are changed by sending
                ' a PROGRAM_CHANGE.  If we received a PROGRAM_CHANGE on the
                ' current MIDI channel from an external MIDI device, we
                ' will update the patch name on the screen and send the patch
                ' change out the MIDI Out.
                '
                 ComboPatch.ListIndex = MIDIOutput1.Data1

            '
            'Controller Change received
            '
            Case CONTROLLER_CHANGE + MidiChannelOut
                Select Case InData1
                    Case MAIN_VOLUME
                        HSliderVolume.Value = InData2
                    Case PAN
                        KnobPan.Value = InData2
                End Select
            
            Case Else
                '
                'Tell MIDIOutput1 to send the MIDI data
                '
                MIDIOutput1.Action = MIDIOUT_SEND
                
        End Select

        '
        'Remove the MIDI data from the MIDI IN queue
        '
        MIDIInput1.Action = MIDIIN_REMOVE
    Loop
End Sub

Private Sub MIDISetup_Click()
    MIDISetupForm.Show MODAL
End Sub

Private Sub PanelWhite_DragDrop(Index As Integer, Source As Control, X As Single, Y As Single)
    Dim nn As Integer
    For nn = 0 To NoteCatchCount - 1
        MIDIOutput1.Message = NOTE_ON + MidiChannelOut
        MIDIOutput1.Data2 = 0
        MIDIOutput1.Data1 = NoteOnCatcher(nn)
        MIDIOutput1.Time = 0
        MIDIOutput1.Action = MIDIOUT_SEND

        frmMain.PanelWhite(NoteOnCatcher(nn) - Octave(MidiChannelOut)).BevelOuter = 2
    Next nn

    NoteCatchCount = 0
End Sub

Private Sub PanelWhite_DragOver(Index As Integer, Source As Control, X As Single, Y As Single, State As Integer)
    Dim MIDIMessage As Integer
    Dim MIDINoteOut As Integer

    MIDINoteOut = Index + Octave(MidiChannelOut)

    'If still on same note, discard
    If NoteCatchCount > 0 Then
       If NoteOnCatcher(NoteCatchCount - 1) = MIDINoteOut Then
            Exit Sub
       End If
    End If

    frmMain.PanelWhite(Index).BevelOuter = 0
        
    MIDIOutput1.Message = NOTE_ON + MidiChannelOut
    MIDIOutput1.Data2 = MidiVelocity
    MIDIOutput1.Data1 = MIDINoteOut
    MIDIOutput1.Time = 0
    MIDIOutput1.Action = MIDIOUT_SEND

    'Since drag/drop is being used, we must keep track of the note being
    'played.
    NoteOnCatcher(NoteCatchCount) = MIDINoteOut
    If NoteCatchCount < 750 Then
        NoteCatchCount = NoteCatchCount + 1
    End If

End Sub

